/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bswfx;

import bswfx.handler.*;
import bs.Game;
import org.json.JSONArray;
import org.json.JSONObject;
import rsx.BomberStudentClient;
import wfx.WebFx;

/**
 *
 * @author Loquicom <contact@loquicom.fr>
 */
public class BomberStudent {
    
    public static WebFx wfx = new WebFx();
    
    public static BomberStudentClient bsc = new BomberStudentClient();
    
    public static Game game;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        //Change passage de ligne du systeme
        System.setProperty("line.separator", "\n");
        
        //Variables
        JSONObject param;
        JSONObject res;
        
        //Lancement Thread affichage
        Thread twfx = new Thread(wfx);
        twfx.start();
        
        //Ajout handler
        bsc.addHandler("server/end", new HandlerServerEnd());
        bsc.addHandler("player/position/update", new HandlerPlayerMove());
        bsc.addHandler("game/newplayer", new HandlerPlayerJoin());
        bsc.addHandler("game/quit", new HandlerPlayerQuit());
        bsc.addHandler("attack/newbomb", new HandlerAttackBomb());
        bsc.addHandler("attack/explose", new HandlerAttackExplose());
        bsc.addHandler("attack/affect", new HandlerAttackAffect());
        bsc.addHandler("player/major/end", new HandlerMajorEnd());
        
        //Recherche serveur actif
        int nbRes = bsc.findServer();
        if (nbRes == 0) {
            System.err.println("Aucun serveur");
            wfx.end();
            System.exit(0);
        }
        System.out.println("Nombre serveur : " + nbRes);
        
        //Connexion serveur et recup liste des games
        bsc.selectServer(0);
        bsc.send("GET", "game/list");
        res = bsc.receive();
        
        //Verif si une game de test existe
        boolean gameTest = false;
        if(res.getInt("numberGameList") != 0){
            JSONArray ja = res.getJSONArray("games");
            for(int i = 0; i < ja.length(); i++){
                JSONObject jo = ja.getJSONObject(i);
                if(jo.getString("name").equals("gameTest")){
                    gameTest = true;
                    break;
                }
            }
        }
        //Si pas de game creation
        if(!gameTest){
            //Verif que la mapTest est présente
            JSONArray ja = res.getJSONArray("maps");
            boolean present = false;
            for(int i = 0; i < ja.length(); i++){
                if(ja.getString(i).equals("mapTest")){
                    present = true;
                    break;
                }
            }
            if(!present){
                System.err.println("La map de test n'est pas présente sur le serveur");
                end();
            }
            //Creation game
            param = new JSONObject();
            param.put("name", "gameTest");
            param.put("map", "mapTest");
            bsc.send("POST", "game/create", param);
            res = bsc.receive();
            if(res.getInt("status") != 201){
                System.err.println("Impossible de créer la game");
                end();
            }
        } 
        //Sinon on rejoint
        else {
            param = new JSONObject();
            param.put("name", "gameTest");
            bsc.send("POST", "game/join", param);
            res = bsc.receive();
            if(res.getInt("status") != 201){
                System.err.println("Impossible de rejoindre la game");
                end();
            }
        }
        //Creation game
        game = new Game(res);
        updateWindow();
        ScreenManager.setScreen(ScreenManager.GAME_SCREEN);
    }
    
    public static void updateWindow(){
        wfx.loadHtml(game.toHtml());
    }
    
    public static void end(){
        wfx.end();
        bsc.close();
        System.exit(0);
    }

}
